"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

Object.defineProperty(exports, "__esModule", {
  value: true
});

var global_state_1 = require("./global-state");

var observer_1 = require("./observer");

var utils_1 = require("./utils");

var Atom =
/*#__PURE__*/
function () {
  function Atom() {
    var onBecomeObservedHandler = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : utils_1.noop;
    var onBecomeUnobservedHandler = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : utils_1.noop;
    (0, _classCallCheck2.default)(this, Atom);

    /**
     * All reactions with this atom.
     */
    this.reactions = new Set();
    this.isBeingTracked = false;
    this.onBecomeObservedHandler = onBecomeObservedHandler;
    this.onBecomeUnobservedHandler = onBecomeUnobservedHandler;
  }
  /**
   * Report observe, will trigger onBecomeObservedHandler in the first time.
   */


  (0, _createClass2.default)(Atom, [{
    key: "reportObserved",
    value: function reportObserved() {
      observer_1.startBatch();

      if (global_state_1.globalState.currentReaction) {
        // Binding current reaction
        this.reactions.add(global_state_1.globalState.currentReaction);
      }

      if (!this.isBeingTracked) {
        this.isBeingTracked = true;
        this.onBecomeObservedHandler();
      }

      observer_1.endBatch();
    }
    /**
     * report changed, so will trigger all reactions.
     */

  }, {
    key: "reportChanged",
    value: function reportChanged() {
      this.reactions.forEach(function (reaction) {
        observer_1.runReaction(reaction);
      });
    }
  }, {
    key: "unobserve",
    value: function unobserve() {
      this.isBeingTracked = false;
      this.reactions.clear();
      this.onBecomeUnobservedHandler();
    }
  }]);
  return Atom;
}();

exports.Atom = Atom;