"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

Object.defineProperty(exports, "__esModule", {
  value: true
});

var index_1 = require("../src/index");

var Clock =
/*#__PURE__*/
function () {
  function Clock() {
    var _this = this;

    (0, _classCallCheck2.default)(this, Clock);
    this.intervalHandler = null;
    this.currentDateTime = 1;
    this.atom = new index_1.Atom(function () {
      return _this.startTicking();
    }, function () {
      return _this.stopTicking();
    });
  }

  (0, _createClass2.default)(Clock, [{
    key: "stopAtom",
    value: function stopAtom() {
      this.atom.unobserve();
    }
  }, {
    key: "getTime",
    value: function getTime() {
      this.atom.reportObserved();
      return this.currentDateTime;
    }
  }, {
    key: "startTicking",
    value: function startTicking() {
      this.currentDateTime++;
      this.atom.reportChanged();
    }
  }, {
    key: "stopTicking",
    value: function stopTicking() {
      clearInterval(this.intervalHandler);
      this.intervalHandler = null;
    }
  }]);
  return Clock;
}();

test('basic test', function () {
  var time = 0;
  var clock = new Clock();
  index_1.observe(function () {
    time = clock.getTime();
  });
  clock.startTicking();
  clock.startTicking();
  clock.startTicking();
  return Promise.resolve().then(function () {
    return expect(time === 5).toBe(true);
  });
});
test('unobservable', function () {
  var time = 0;
  var clock = new Clock();
  index_1.observe(function () {
    time = clock.getTime();
  });
  clock.startTicking();
  clock.startTicking();
  clock.stopAtom();
  return Promise.resolve().then(function () {
    return expect(time === 4).toBe(true);
  });
});