"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var __decorate = void 0 && (void 0).__decorate || function (decorators, target, key, desc) {
  var c = arguments.length,
      r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
      d;
  if ((typeof Reflect === "undefined" ? "undefined" : (0, _typeof2.default)(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
    if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  }
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var index_1 = require("../src/index");

function immediate(fn, time) {
  if (time) {
    return new Promise(function (resolve) {
      return setTimeout(function () {
        fn();
        resolve();
      }, time);
    });
  }

  return Promise.resolve().then(function () {
    fn();
  });
}

exports.immediate = immediate;
test('debug', function () {
  index_1.useStrict();
  index_1.startDebug();
  var data = '';
  var dynamicObj = index_1.observable({
    name: 'b'
  });
  data += 'a';
  index_1.observe(function () {
    return data += dynamicObj.name;
  });
  data += 'c';
  index_1.Action(function () {
    dynamicObj.name = 'd';
  });
  index_1.stopDebug();
  index_1.cancelStrict();
  return immediate(function () {
    return expect(data === 'abcd').toBe(true);
  });
});
test('nested debug', function () {
  index_1.useStrict();
  index_1.startDebug();
  var data = '';
  var dynamicObj = index_1.observable({
    user: {
      name: 'b'
    }
  });
  data += 'a';
  index_1.observe(function () {
    return data += dynamicObj.user.name;
  });
  data += 'c';
  index_1.Action(function () {
    dynamicObj.user.name = 'd';
  });
  index_1.stopDebug();
  index_1.cancelStrict();
  return immediate(function () {
    return expect(data === 'abcd').toBe(true);
  });
});
test('debug out of action', function () {
  index_1.startDebug();
  var data = '';
  var dynamicObj = index_1.observable({
    name: 'b'
  });
  data += 'a';
  index_1.observe(function () {
    return data += dynamicObj.name;
  });
  data += 'c';
  index_1.Action(function () {
    dynamicObj.name = 'd';
  });
  dynamicObj.name = 'e';
  index_1.stopDebug();
  return immediate(function () {
    return expect(data === 'abcde').toBe(true);
  });
});
test('test callstack',
/*#__PURE__*/
(0, _asyncToGenerator2.default)(
/*#__PURE__*/
_regenerator.default.mark(function _callee2() {
  return _regenerator.default.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          return _context2.abrupt("return", immediate(
          /*#__PURE__*/
          (0, _asyncToGenerator2.default)(
          /*#__PURE__*/
          _regenerator.default.mark(function _callee() {
            var Store, store, once, callStack;
            return _regenerator.default.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    index_1.startDebug();

                    Store = function Store() {
                      (0, _classCallCheck2.default)(this, Store);
                      this.a = {
                        b: {
                          c: {
                            d: {
                              e: {
                                f: 'b'
                              }
                            }
                          }
                        }
                      };
                    };

                    Store = __decorate([index_1.observable], Store);
                    store = new Store();
                    once = true;
                    callStack = [];
                    index_1.dobEvent.on('debug', function (debugInfo) {
                      if (!once) {
                        return;
                      }

                      once = false;
                      callStack = debugInfo.changeList[0].callStack || [];
                    });
                    store.a.b.c.d.e.f = 'd';
                    index_1.stopDebug();
                    return _context.abrupt("return", immediate(function () {
                      return expect(callStack.length === 6).toBe(true);
                    }));

                  case 10:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee, this);
          })), 0));

        case 1:
        case "end":
          return _context2.stop();
      }
    }
  }, _callee2, this);
})));
test('test overflow callstack',
/*#__PURE__*/
(0, _asyncToGenerator2.default)(
/*#__PURE__*/
_regenerator.default.mark(function _callee4() {
  return _regenerator.default.wrap(function _callee4$(_context4) {
    while (1) {
      switch (_context4.prev = _context4.next) {
        case 0:
          return _context4.abrupt("return", immediate(
          /*#__PURE__*/
          (0, _asyncToGenerator2.default)(
          /*#__PURE__*/
          _regenerator.default.mark(function _callee3() {
            var Store, store, once, callStack;
            return _regenerator.default.wrap(function _callee3$(_context3) {
              while (1) {
                switch (_context3.prev = _context3.next) {
                  case 0:
                    index_1.startDebug();
                    index_1.globalState.getCallstackMaxCount = 3;

                    Store = function Store() {
                      (0, _classCallCheck2.default)(this, Store);
                      this.a = {
                        b: {
                          c: {
                            d: {
                              e: {
                                f: 'b'
                              }
                            }
                          }
                        }
                      };
                    };

                    Store = __decorate([index_1.observable], Store);
                    store = new Store();
                    once = true;
                    callStack = [];
                    index_1.dobEvent.on('debug', function (debugInfo) {
                      if (!once) {
                        return;
                      }

                      once = false;
                      callStack = debugInfo.changeList[0].callStack || [];
                    });
                    store.a.b.c.d.e.f = 'd';
                    index_1.stopDebug();
                    index_1.globalState.getCallstackMaxCount = 50;
                    return _context3.abrupt("return", immediate(function () {
                      return expect(callStack.length === 3).toBe(true);
                    }));

                  case 12:
                  case "end":
                    return _context3.stop();
                }
              }
            }, _callee3, this);
          })), 0));

        case 1:
        case "end":
          return _context4.stop();
      }
    }
  }, _callee4, this);
})));
test('test action',
/*#__PURE__*/
(0, _asyncToGenerator2.default)(
/*#__PURE__*/
_regenerator.default.mark(function _callee6() {
  return _regenerator.default.wrap(function _callee6$(_context6) {
    while (1) {
      switch (_context6.prev = _context6.next) {
        case 0:
          return _context6.abrupt("return", immediate(
          /*#__PURE__*/
          (0, _asyncToGenerator2.default)(
          /*#__PURE__*/
          _regenerator.default.mark(function _callee5() {
            var CustomAction, action, once;
            return _regenerator.default.wrap(function _callee5$(_context5) {
              while (1) {
                switch (_context5.prev = _context5.next) {
                  case 0:
                    index_1.startDebug();

                    CustomAction =
                    /*#__PURE__*/
                    function () {
                      function CustomAction() {
                        (0, _classCallCheck2.default)(this, CustomAction);
                      }

                      (0, _createClass2.default)(CustomAction, [{
                        key: "action1",
                        value: function action1() {
                          this.action2();
                        }
                      }, {
                        key: "action2",
                        value: function action2() {
                          this.action3();
                        }
                      }, {
                        key: "action3",
                        value: function action3() {}
                      }]);
                      return CustomAction;
                    }();

                    __decorate([index_1.Action], CustomAction.prototype, "action1", null);

                    __decorate([index_1.Action], CustomAction.prototype, "action2", null);

                    __decorate([index_1.Action], CustomAction.prototype, "action3", null);

                    action = new CustomAction();
                    once = false;
                    index_1.dobEvent.on('debug', function (debugInfo) {
                      if (!once) {
                        return;
                      }

                      once = false;
                      delete debugInfo.id;
                      expect(debugInfo).toEqual({
                        name: 'CustomAction.action1',
                        changeList: [{
                          type: 'action',
                          action: {
                            name: 'CustomAction.action2',
                            changeList: [{
                              type: 'action',
                              action: {
                                name: 'CustomAction.action3',
                                changeList: [],
                                type: 'action'
                              }
                            }],
                            type: 'action'
                          }
                        }],
                        type: 'action'
                      });
                    });
                    action.action1();
                    index_1.stopDebug();
                    return _context5.abrupt("return", immediate(function () {
                      return expect(true).toBe(true);
                    }));

                  case 11:
                  case "end":
                    return _context5.stop();
                }
              }
            }, _callee5, this);
          })), 0));

        case 1:
        case "end":
          return _context6.stop();
      }
    }
  }, _callee6, this);
})));
test('test delete',
/*#__PURE__*/
(0, _asyncToGenerator2.default)(
/*#__PURE__*/
_regenerator.default.mark(function _callee8() {
  return _regenerator.default.wrap(function _callee8$(_context8) {
    while (1) {
      switch (_context8.prev = _context8.next) {
        case 0:
          return _context8.abrupt("return", immediate(
          /*#__PURE__*/
          (0, _asyncToGenerator2.default)(
          /*#__PURE__*/
          _regenerator.default.mark(function _callee7() {
            var dynamicObj, once;
            return _regenerator.default.wrap(function _callee7$(_context7) {
              while (1) {
                switch (_context7.prev = _context7.next) {
                  case 0:
                    index_1.startDebug();
                    dynamicObj = index_1.observable({
                      name: 'b'
                    });
                    once = true;
                    index_1.dobEvent.on('debug', function (debugInfo) {
                      if (!once) {
                        return;
                      }

                      once = false;
                      delete debugInfo.id;
                      expect(debugInfo).toEqual({
                        name: null,
                        changeList: [{
                          type: 'delete',
                          callStack: ['Object'],
                          key: 'name'
                        }],
                        type: 'isolated'
                      });
                    });
                    delete dynamicObj.name;
                    return _context7.abrupt("return", immediate(function () {
                      return expect(true).toBe(true);
                    }));

                  case 6:
                  case "end":
                    return _context7.stop();
                }
              }
            }, _callee7, this);
          })), 0));

        case 1:
        case "end":
          return _context8.stop();
      }
    }
  }, _callee8, this);
})));