"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var event_1 = require("../src/event");

test('test on', function () {
  var count = 0;
  var event = new event_1.Event();
  event.emit('change', 1);
  event.on('change', function (changedValue) {
    count += changedValue;
  });
  event.emit('change', 2);
  expect(count === 2).toBe(true);
});
test('test multiple on', function () {
  var count = 0;
  var event = new event_1.Event();
  event.emit('change', 1);
  event.on('change', function (changedValue) {
    count += changedValue;
  });
  event.on('change', function (changedValue) {
    count += changedValue;
  });
  event.emit('change', 2);
  expect(count === 4).toBe(true);
});
test('test off', function () {
  var count = 0;
  var event = new event_1.Event();
  event.emit('change', 1);

  function changeValue(changedValue) {
    count += changedValue;
  }

  event.on('change', changeValue);
  event.on('change', changeValue);
  event.emit('change', 2);
  event.off('change', changeValue);
  event.emit('change', 2);
  expect(count === 4).toBe(true);
});
test('test off not exist event', function () {
  var count = 0;
  var event = new event_1.Event();
  event.emit('change', 1);

  function changeValue(changedValue) {
    count += changedValue;
  }

  event.on('change', changeValue);
  event.on('change', changeValue);
  event.emit('change', 2);
  event.off('someThing', changeValue);
  event.emit('change', 2);
  expect(count === 8).toBe(true);
});