"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var index_1 = require("../src/index");

test("reaction 初始化不会执行 callback", function () {
  var flag = false; // tslint:disable-next-line:no-unused-expression

  new index_1.Reaction("test", function () {
    flag = true;
  });
  expect(flag).toBe(false);
});
test("reaction 手动执行", function () {
  var flag = false;
  var reaction = new index_1.Reaction("test", function () {
    flag = true;
  });
  reaction.run();
  expect(flag).toBe(true);
});
test("reaction 绑定与构造函数无关，与 track 有关", function () {
  var values = [];
  var obj = index_1.observable({
    a: 1,
    b: 2
  });
  var reaction = new index_1.Reaction("test", function () {
    // 使用 a
    values.push(obj.a);
  });
  reaction.track(function () {
    // 绑定的是 b
    // tslint:disable-next-line:no-unused-expression
    obj.b;
  });
  obj.b = 3;
  obj.b = 4;
  obj.a = 8;
  obj.a = 9;
  expect(values.length === 2).toBe(true);
  expect(values[0] === 1).toBe(true);
  expect(values[1] === 1).toBe(true);
});